/* linux/arithm.h
*
*  1995 Michael Barabanov
*/


typedef struct
  {
    unsigned long quot;	/* Quotient.  */
    unsigned long rem;	/* Remainder.  */
  } uldiv_t;

/*  a * mult / div  */

inline uldiv_t ulmuldivmod( unsigned long a, unsigned long mult, 
				unsigned long div) {
	register uldiv_t  res;
	__asm__("mull %1 ; divl %3"
		:"=a" (res.quot),
		"=d" (res.rem)
		:"1" (mult),
		 "r" (div),
		 "0" (a)
		:"dx");
	return res;
}


/* round (a * mult/div) */

inline unsigned long ulmuldivround( unsigned long a, unsigned long mult, 
				     unsigned long div) {
 register uldiv_t r;
 r = ulmuldivmod( a, mult, div);
 if ( r.rem * 2 >= div) r.quot++;
 return r.quot;
} 


