/* rtcontext.h
 *
 */
#ifndef __RT_CONTEXT
#define __RT_CONTEXT

#include <asm/segment.h>

/* this might change */ 
#define RT_USER_CS    0x30
#define RT_USER_DS    0x38


#define __STR(x) #x
#define STR(x) __STR(x)

#define SAVE_LEAST \
	"push %ds\n\t \
	pushl %eax\n\t \
	pushl %edx\n\t \
	pushl %ecx\n\t \
	movl $"  STR( KERNEL_DS) ",%edx\n\t \
	mov %dx,%ds\n\t"

#define RESTORE_LEAST \
	"popl %ecx\n\t \
	popl %edx\n\t \
	popl %eax\n\t \
	pop %ds\n\t" 



#define SAVE_RT_CONTEXT \
	"cld\n\t" \
	"push %fs\n\t" \
	"push %es\n\t" \
	"push %ds\n\t" \
	"pushl %eax\n\t" \
	"pushl %ebp\n\t" \
	"pushl %edi\n\t" \
	"pushl %esi\n\t" \
	"pushl %edx\n\t" \
	"pushl %ecx\n\t" \
	"pushl %ebx\n\t" \
	"movl $" STR(KERNEL_DS) ",%edx\n\t" \
	"mov %dx,%ds\n\t" \
	"mov %dx,%es\n\t" \
	"movl $" STR(RT_USER_DS) ",%edx\n\t" \
	"mov %dx,%fs\n\t"

#define RT_EAX 0x18

#define RESTORE_RT_CONTEXT \
	"popl %ebx\n\t \
	popl %ecx\n\t \
	popl %edx\n\t \
	popl %esi\n\t \
	popl %edi\n\t \
	popl %ebp\n\t \
	popl %eax\n\t \
	pop %ds\n\t \
	pop %es\n\t \
	pop %fs\n\t"


#endif
