#ifndef __RTMM
#define __RTMM


#include <linux/mm.h>
#include <linux/malloc.h>

extern inline unsigned long RTget_page( void) {
 return __get_free_page( GFP_KERNEL);
}

extern inline void RTfree_page( unsigned long page) {
 free_page( page);
}

inline extern void * RTkmalloc( unsigned int size) {
 return kmalloc( size, GFP_KERNEL);
}

inline extern void RTkfree( void * obj) {
 kfree( obj);
}

struct RTmm_info {
 unsigned long pgdir;
};


extern int RTmm_init( struct RTmm_info * mm);

extern int RTmm_map_user( struct RTmm_info * mm, unsigned long addr, unsigned long len);

extern int RTmm_alloc_user( struct RTmm_info * mm, unsigned long len, 
				unsigned long * result);

extern int RTsys_mmap( unsigned long addr, unsigned long len, 
				unsigned long * result);

extern void RTmm_free_user( struct RTmm_info *mm);


extern inline void RTmm_save_active( struct RTmm_info *mm) {
 __asm__ __volatile__("mov %%cr3,%0": "=r" (mm->pgdir):); 
}

extern inline void RTmm_restore_active( struct RTmm_info *mm) {
 __asm__ __volatile__("mov %0,%%cr3": : "r" (mm->pgdir)); 
}

#endif

