#ifndef _RTSYS_CALL
#define _RTSYS_CALL

#define __RT_RTtest0		 0
#define __RT_RTtest1		 1
#define __RT_RTputs		 2
#define __RT_RTgetpid		 3
#define __RT_RTrun		 4
#define __RT_RTwait_period	 5
#define __RT_RTset_params	 6
#define __RT_RTwait_start	 7
#define __RT_RTkill		 8
#define __RT_RTfifo_put		 9
#define __RT_RTfifo_get		10
#define __RT_RTmmap		11

#define _RTsyscall0(type,name) \
type name(void) \
{ \
long __res; \
__asm__ volatile ("int $0x81" \
	: "=a" (__res) \
	: "0" (__RT_##name)); \
if (__res >= 0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _RTsyscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
long __res; \
__asm__ volatile ("int $0x81" \
	: "=a" (__res) \
	: "0" (__RT_##name),"b" ((long)(arg1))); \
if (__res >= 0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _RTsyscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
long __res; \
__asm__ volatile ("int $0x81" \
	: "=a" (__res) \
	: "0" (__RT_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
if (__res >= 0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _RTsyscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("int $0x81" \
	: "=a" (__res) \
	: "0" (__RT_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3))); \
if (__res>=0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}

#define _RTsyscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
{ \
long __res; \
__asm__ volatile ("int $0x81" \
	: "=a" (__res) \
	: "0" (__RT_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4))); \
if (__res>=0) \
	return (type) __res; \
errno = -__res; \
return -1; \
} 

#define _RTsyscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5) \
{ \
long __res; \
__asm__ volatile ("int $0x81" \
	: "=a" (__res) \
	: "0" (__RT_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5))); \
if (__res>=0) \
	return (type) __res; \
errno = -__res; \
return -1; \
}


#endif
