/*
 * rtthread.h
 * 1995  Michael Barabanov  
 */
#ifndef __RTTHREAD
#define __RTTHREAD


#include <linux/linkage.h>
#include <asm/rtmm.h>

#define RT_IO_BITMAP_SIZE	32

struct RTthread {
	unsigned short	back_link,__blh;	/* 0x00 */
	unsigned long	esp0;			/* 0x04 */
	unsigned short	ss0,__ss0h;		/* 0x08 */
	unsigned long	esp1;			/* 0x0C */
	unsigned short	ss1,__ss1h;		/* 0x10 */
	unsigned long	esp2;			/* 0x14 */
	unsigned short	ss2,__ss2h;		/* 0x18 */
	unsigned long	cr3;			/* 0x1C */
	unsigned long	eip;			/* 0x20 */
	unsigned long	eflags;			/* 0x24 */
	unsigned long	eax,ecx,edx,ebx;
	unsigned long	esp;
	unsigned long	ebp;
	unsigned long	esi;
	unsigned long	edi;
	unsigned short	es, __esh;
	unsigned short	cs, __csh;
	unsigned short	ss, __ssh;
	unsigned short	ds, __dsh;
	unsigned short	fs, __fsh;
	unsigned short	gs, __gsh;
	unsigned short	ldt, __ldth;
	unsigned short	trace, bitmap;
	unsigned long	io_bitmap[RT_IO_BITMAP_SIZE+1];
};

extern void RTinit_thread( struct RTthread *tss, long code, 
	long kernelstack, long userstack, struct RTmm_info *mm);

#endif

