/* rtsched.h
 *
 */
#ifndef __RTSCHED
#define __RTSCHED


#include <asm/rttime.h>


#ifdef __KERNEL__

#include <asm/rtthread.h>
#include <asm/rtmm.h>


#define RT_TASK_FREE		0
#define RT_TASK_RUNNING		1
#define RT_TASK_STOPPED		2
#define RT_TASK_RUNNABLE	3
#define RT_TASK_WAITING 	4


struct RTtask_struct {
 struct RTthread tss; /* hardcoded; should always be the first member of RTtask_struct */ 
 unsigned long kernel_stack;
 struct RTmm_info mm;
 int pid;

 long state;
 int priority;
 RTime resume_time;
 RTime period;
};


extern struct RTtask_struct  *RTtask_ptr( int pid);

extern int RTtask_alloc( void);

extern void RTtask_free( int pid);


extern struct RTtask_struct  *RTcurrent;
extern struct RTtask_struct  *RTnew_task;  /* task to switch to on RTret_from_sys_call */

extern int RTsys_run( int pid);

extern int RTsys_set_params( RTime *start, RTime *period, int priority);
extern int RTsys_wait_start( RTime *start, RTime *period, int priority);
extern int RTsys_wait_period( void);

extern int RTsys_getpid( void);
extern int RTsys_kill( int pid);

extern void RTsched_init( void);

#endif
#endif

