#include <errno.h>
#include <asm/unistd.h>
#include <linux/rtlinux.h>

#define __NR_RTfifo_create   202
#define __NR_RTfifo_destroy  203
#define __NR_RTfifo_put      204
#define __NR_RTfifo_get      205

_syscall2(int, RTfifo_create, unsigned int, fifo, int, size);
_syscall1(int, RTfifo_destroy, unsigned int, fifo);

_syscall3(int, RTfifo_put, unsigned int, fifo, char *, buf, int, count);

_syscall3(int, RTfifo_get, unsigned int, fifo, char *, buf, int, count);


int RTfifo_read( unsigned int fifo, char * buf, int count) {
 int ret;
 while ( (ret = RTfifo_get( fifo, buf, count)) < 0);
 return ret;
}

int RTfifo_write( unsigned int fifo, char * buf, int count) {
 int ret;
 while ( (ret = RTfifo_put( fifo, buf, count)) < 0);
 return ret;
}

