#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <linux/rtlinux.h>

char buf1[100];
char buf2[100];

int p1, p2;

void cleanup() {
 printf("Killing RT-processes ...\n");
 RTkill(p1);
 RTkill(p2);
 RTfifo_destroy( 1);
 RTfifo_destroy( 2);
 RTfifo_destroy( 3);
 RTfifo_destroy( 4);
 exit(1);
}


RTime start1, start2, period1, period2;
int prio1, prio2;

int main( int argc, char **argv) {
 RTime now;

 if (signal( SIGINT, SIG_IGN) != SIG_IGN) {
   signal( SIGINT, cleanup);
 }

 p1 = RTload( "rt1"); 
 p2 = RTload( "rt2"); 


 RTfifo_create( 1, 100);
 RTfifo_create( 2, 100);
 RTfifo_create( 3, 10000);
 RTfifo_create( 4, 10000);
 
 printf("pid1 = %d,  pid2 = %d\n", p1, p2);
 RTget_time( &now);
 
 start1 =  now + 1000000;
 period1 = 5000;
 prio1 = 1;
 start2 =  now + 2000000;
 period2 = 10000;
 prio2 = 2;

 RTfifo_write( 1, (char *) &start1, sizeof( start1));
 RTfifo_write( 1, (char *) &period1, sizeof( period1));
 RTfifo_write( 1, (char *) &prio1, sizeof( prio1));

 RTfifo_write( 2, (char *) &start2, sizeof( start2));
 RTfifo_write( 2, (char *) &period2, sizeof( period2));
 RTfifo_write( 2, (char *) &prio2, sizeof( prio2));

 RTrun( p1);
 RTrun( p2);

 while(1) {
   if ( RTfifo_get( 3, buf1, 70) > 0) {
     buf1[71]=0; 
     printf("Task1: %s\n", buf1);
   }

   if ( RTfifo_get( 4, buf2, 70) > 0) {
     buf2[71]=0; 
     printf("Task2: %s\n", buf2);
   }
 }
 
 cleanup();
 return 0;
}

